#
Prev |  | Next

# appletFactory

## Name

appletFactory -- A command which creates a Gnome panel applet.

## Synopsis

appletFactory `iid` `command`

## Screenshot

## Options

-background

  type: color

  Background color of the widget.

-child

  type: widget-ID

  Widget ID of the child.

-dragTargets

  type: list of strings

  List of source targets (e.g. text/plain or application/x-color) which are supported.

-dropTargets

  type: list of strings

  List of destination targets (e.g. text/plain or application/x-color) which are supported.

-name

  type: string

  Name of the widget, can be used to set options in an rc file.

-onButtonPress

  type: string (default: "")

  Tcl command which is executed if a mouse button is press inside the widget. Before evaluation the following percent strings are substituated: TABLE %% | % %w | widget name %t | type of event: one of buttonPress, button2Press or button3Press %x | x coordinate %y | y coordinate %b | button number %s | state of the buttons and modifiers (bitmask) TABLE

-onButtonRelease

  type: string (default: "")

  Tcl command which is executed if a mouse button is released inside the widget. Before evaluation the following percent strings are substituated: TABLE %% | % %w | widget name %t | type of event: always buttonRelease %x | x coordinate %y | y coordinate %b | button number %s | state of the buttons and modifiers (bitmask) TABLE

-onChangeOrientation

  type: string (default: "")

  Command to be executed in the global scope if the panel including the applet changes its orientation. Before evaluation the following percent strings are substituted: TABLE %% | % %w | widget name. TABLE

-onChangeSize

  type: string (default: "")

  Command to be executed in the global scope if the panel including the applet changes its size. Before evaluation the following percent strings are substituted: TABLE %% | % %w | widget name. TABLE

-onDestroy

  type: string (default: "")

  Tcl command which is executed if the widget is destroyed. Before evaluation the following percent strings are substituated: TABLE %% | % %w | widget name. TABLE

-onDragData

  type: string (default: "")

  Tcl command which is executed if data is draged from this the widget to another. This command must return the data to be draged. Before evaluation the following percent strings are substituated: TABLE %% | % %w | widget name %t | time %T | type of data TABLE

-onDropData

  type: string (default: "")

  Tcl command which is executed if data is dropped on the widget. Before evaluation the following percent strings are substituated: TABLE %% | % %w | widget name %d | data %l | length of data %t | time %T | type of data %x | x coordinate %y | y coordinate TABLE

-onMotion

  type: string (default: "")

  Tcl command which is executed if the mouse is moved inside the widget. Before evaluation the following percent strings are substituated: TABLE %% | % %w | widget name %x | x coordinate %y | y coordinate %s | state of the buttons and modifiers (bitmask) TABLE

-onPopupMenu

  type: string (default: "")

  Tcl command which is executed if the "popup-menu" signal is recieved, which is normally the case if the user presses Shift-F10. Before evaluation the following percent strings are substituated: %w by widget name.

-onRealize

  type: string (default: "")

  Tcl command whih is executed in the global scope if the widget has been realized. Before evaluation the following percent strings are substituated: TABLE %% | % %w | widget name. TABLE

-onShowHelp

  type: string (default: "")

  Tcl command which is executed in the global scope if the "show-help" signal is recieved, which is normally the case if the user presses F1 or Ctrl-F1. Before evaluation the following percent strings are substituated TABLE %% | % %w | widget name %h | help type: either "whatsThis" or "tooltip" TABLE

-sensitive

  type: boolean (default: 1)

  Whether or not the item is sensitve to user input.

-tooltip

  type: string

  Message that appear next to this widget when the mouse pointer is held over it for a short amount of time.

-visible

  type: boolean (default: 1)

  Whether or not the item is visible.

## Description

The appletFactory creates a Gnome panel applet. An additional matching Bonobo Activation server file is needed. The appletFactory command has two parameters. iid is the ID which must correspond to the oaf_server iid entry in the server file. command is executed when gnome creates the applet. The following percent strings are substituted: TABLE %% | % %i | iid %w | name of the newly created applet /TABLE The above widget commands and options are applicable to this newly created applet.

## Commands

`id` addMenuItem [`-option` `value`...]

  Adds an entry to the panel menu.

  Options

  -text

    type: percent-string (default: "")

    Text or stock item of the entry.

  -onClicked

    type: string (default: "")

    Command to be executed in the global scope if entry is chosen. Before evaluation the following percent strings are substituted: TABLE %% | % /TABLE

`id` addMenuSeparator

  Adds a separator to the panel menu.

`id` getSize

  Returns the size of the applet in pixel.

`id` getOrientation

  Returns the orientation of the panel as one of up, down, left or right. The orientation is not the same as the side on the screen the panel is on. If the panel is for example on the right side of the screen, the orientation is left.

`id` configure [`-option` `value`...]

  Configures the widget. Option may have any of the values accepted on creation of the widget.

`id` delete

  Deletes the widget and the associated tcl command.

## Example

    namespace eval gnocl {
       set appName "gnocl_test_applet"
    }
    package require gnoclGnome
    proc makeMenu { w } {
       $w addMenuItem -text "%#About" -onClicked {gnocl::dialog -text "About"}
    }
    proc createApplet {w iid} {
       set box [gnocl::box -orientation vertical]
       $box add [gnocl::button -text "Hello, world!" -onClicked "puts onClicked"]
       $w configure -child $box -onRealize "makeMenu %w"
    }
    gnocl::appletFactory OAFIID:gnocl_test_applet_factory {createApplet %w %i}

results in

Prev | Home | Next
Commands | Up | session